#include "castle20.inc"
#include "colors.inc"
#include "Golds.inc"
#include "metals.inc"
#include "skies.inc"
//#include "woods.inc"
#include "textures.inc"


camera {    //prueba 1 de camara para portada
   location <0, 25,-60>
   direction <0.0, 0.0, 1>
   up  <0.0, 1.0, 0.0>
   right <1.33,0.0, 0.0>                    
   look_at <0,25,0> 
//   look_at <0,0,0> 
} 



//  light_source {<-1500,3550,-3540> color White}
  light_source {<1600,550,-3540> color White}

#declare agua=texture {
    pigment{color rgb <0.258, 0.258, 0.435>}
    normal {
        ripples 0.35
	    frequency 100.0
        turbulence .17
        }
	finish {
        ambient 0.1 diffuse 0.8 phong 1
	    reflection 0.44
//      refraction 1
//      ior 1.5 
        }
	scale <700, 700, 700>
}




//plane{y,0 texture{agua}}
 

sky_sphere { S_Cloud2
}



/*
//           CASTILLO
//torre redonda de 10 ancho*25 de alto con ventanas usada en torbala
#declare torred25=union{ 
    object{secb10_10r}
    object{secm10_10r translate<0,100,0>}
    object{secf10_5r translate<0,200,0>}
}
//torre cuadrada de 15 de alto usada en torbala
#declare torcua15=union{
    object{secb10_10c}
    object{secf10_5c translate<0,100,0>}
}    
//torre base lateral de la estructura principal
#declare torbala=union{
    object{secb20_10r rotate y*90}
    object{secm20_10r translate<0,100,0>}      //ventanas
    object{secm20_10r01 translate<0,200,0> rotate y*45}    //con torcol1
    object{secf20_5r05 translate<0,300,0> rotate y*45}     //techo con 4 puertas
//se aaden 4 torres torred25 en las esquinas
    object{torred25 translate<-100,0,0>}
    object{torred25 translate<-100,0,0> rotate y*90}
    object{torred25 translate<-100,0,0> rotate y*-90}
    object{torred25 translate<-100,0,0> rotate y*180}
// se aaden 4 torres cuadradas intercaladas entre las torres redondas
    object{torcua15 translate<-110,0,0> rotate y*45}
    object{torcua15 translate<-110,0,0> rotate y*-45}
    object{torcua15 translate<-110,0,0> rotate y*(180+45)}
    object{torcua15 translate<-110,0,0> rotate y*-(180+45)}
    }

//torre redonda de 10 ancho*30 de alto con torres colgantes para intercalar
//entre torbalas
#declare torred30=union{ 
    object{secb10_10r}
    object{secm10_5r translate<0,100,0>}
    object{secm10_10r02 translate<0,150,0> rotate y*45}
    object{secf10_5r05 translate<0,250,0> rotate y*45}
}

//Ahora las definiciones para el grupo central de torres del castillo
//y laterales superiores
#declare torcua25=union{ //torres centinelas de base superior
    object{secb10_10c}
    object{secm10_10c01 translate <0,100,0>}
    object{secf10_5c05 translate <0,200,0>}
    object{torpan5_3 rotate y*180 translate <0,250,0>}
}
#declare torcua35=union{ //torres laterales de la estruc. superior princip.
    object{secb10_10c}
    object{secm10_10c translate<0,100,0>}
    object{secm10_10c04 translate <0,200,0>}
    object{secf10_5c05 translate <0,300,0>}
    object{torpan5_3 rotate y*180 translate <0,350,0>}
}
#declare torred15=union{
    object{secb10_10r}
    object{secf10_5r translate<0,100,0>}
}

#declare grupsup=union{
    object{secb20_10r }
    object{secm20_10r translate<0,100,0>}
    object{secm20_10r translate<0,200,0>}
    object{secm20_10r translate<0,300,0>}
    object{secf20_5r translate<0,400,0>}
//las 4 torres laterales del grupo superior
    object{torred15 translate<-85,0,-85>}
    object{torred15 translate<85,0,-85>}
    object{torred15 translate<85,0,-85>}
    object{torred15 translate<-85,0,85>}
//las 4 torres intercaladas de 20 metros de altura
    object{torcua35 translate<0,0,-120>}
    object{torcua35 translate<0,0,-120> rotate y*90}
    object{torcua35 translate<0,0,-120> rotate y*-90}
    object{torcua35 translate<0,0,-120> rotate y*180}
} 

#declare ristra50=union{
    #declare cal=0
/* el valor inicial de xa se debe a que la aspillera esta centrada en 0 y va
    de  -12.50  a  12.50. Asi, si deseamos crear una ristra desde -250 a 250
    xa comenzara a 250-12.50=237.50. */
    #declare xa=-237.5
    #while(cal!=20)
     object{ aspilleraG translate<xa,0,0>}
     #declare cal=cal+1
     #declare xa=xa+25
    #end
    }

declare body50_35=union{   //cuerpo cuadrado de 50 ancho*35 alto
union{
    box{<-249.8,0,-250>,<249.8,400,-249> texture{texcastle}}
    box{<-249.8,0,-250>,<249.8,400,-249> texture{texcastle} rotate y*90}
    box{<-249.8,0,-250>,<249.8,400,-249> texture{texcastle} rotate y*-90}
    box{<-249.8,0,-250>,<249.8,400,-249> texture{texcastle} rotate y*180}
//techo
    box{<-249.8,399,-249.8>,<249.8,400,249.8> texture{texcastle2 rotate x*90}} 
    object{ristra50 translate<0,400,-250>}
    object{ristra50 translate<0,400,-250> rotate y*90}
    object{ristra50 translate<0,400,-250> rotate y*-90}
    object{ristra50 translate<0,400,-250> rotate y*180}
//4 torres laterales principales en las esquinas del castillo
    object{torbala translate<-250,0,-250>}
    object{torbala translate<250,0,-250>}
    object{torbala translate<-250,0,-250> rotate y*180}
//    object{torbala translate<250,0,-250> rotate y*180}
//4 torres torred30 usadas entre las torres laterales de la base
    object{torred30 translate<0,0,-260>}
//    object{torred30 translate<0,0,-260> rotate y*90}
//    object{torred30 translate<0,0,-260> rotate y*-90}
    object{torred30 translate<0,0,-260> rotate y*180}
//sigue el grupo de torres superiores
    object{grupsup translate<0,400,0>}
//y las 4 torres laterales superiores
    object{torcua25 translate<-240,350,-240>}
    object{torcua25 translate<-240,350,-240> rotate y*180}
    object{torpan10_2 translate<240,350,-240>}
//    object{torcua25 translate<240,350,-240>}
//    object{torcua25 translate<240,350,-240> rotate y*180}

    object{colgante1 translate<-125,260,-250>}
    object{colgante1 translate<125,260,-250>}
    object{lateral1_2 translate<0,400,-200>}
//  object{torpan5_1 translate<0,400,-230> rotate y*90}
// incluimos una pequea casita-torre en la cima
    object{secbpan51 rotate y*180 translate<0,300,-260>}
    object{tejpir5 scale <1,.70,1> translate<0,350,-260>}
    rotate y*45
//    translate<-3000,0,3000>
}



//muralla de separacin del castillo con el mar
#declare ristra650=union{
    #declare cal=0
 el valor inicial de xa se debe a que la aspillera esta centrada en 0 y va
    de  -12.50  a  12.50. Asi, si deseamos crear una ristra desde -250 a 250
    xa comenzara a 250-12.50=237.50. 
    #declare xa=-637.5
    #while(cal!=200)
     object{ aspilleraG translate<xa,0,0>}
     #declare cal=cal+1
     #declare xa=xa+25
    #end
    }
union{
    box{<-649.8,0,-450>,<649.8,180,-420> 
        texture{texcastle rotate x*45}
//        pigment{Orange}
        rotate y*90}
    object{ristra650 translate<0,180,-450> rotate y*90}
    rotate y*45
} */





#include "town.inc"
object{panel9// Create an infinite sphere around scene and allow any texture on it



/*
//suelo
//box{<-400,-1,-700>,<400,1,700> pigment{Red} rotate y*45}
box{<-500,-1,-700>,<500,0.1,700> 
//    pigment{image_map{tga "suelo1.tga"} rotate x*90 scale<16,1,16>}
    pigment{Red}
    rotate y*45}

  */
